// #autoload
// #name = WheelMineNade
// #include = support/loadout.cs
// #category = ilys' Scripts

package WheelMineNade {
function MouseConfigDlg::onWake( %this )
{
	MouseXSlider.setValue( moveMap.getScale( mouse, xaxis ) / 2 );
	MouseYSlider.setValue( moveMap.getScale( mouse, yaxis ) / 2 );
	InvertMouseTgl.setValue( moveMap.isInverted( mouse, yaxis ) );
	MouseZActionMenu.clear();
	MouseZActionMenu.add( "Nothing", 1 );
	MouseZActionMenu.add( "Cycle Weapon", 2 );
	MouseZActionMenu.add( "Next Weapon Only", 3 );
	MouseZActionMenu.add( "Mine and Nade", 4 );
	%bind = moveMap.getCommand( "mouse", "zaxis" );
	%selId = 1;
	switch$ ( %bind )
	{
		case "cycleWeaponAxis": %selId = 2;
		case "cycleNextWeaponOnly": %selId = 3;
		case "MineNade": %selId = 4;
	}
	MouseZActionMenu.setSelected( %selId );
	MouseZUpActionMenu.setSelected( $pref::MouseZUpAction );
	MouseZDownActionMenu.setSelected( $pref::MouseZDownAction );
	if(MouseZActionMenu.getSelected() != 4)
	{
		MouseZUpActionMenu.setActive(false);
		MouseZDownActionMenu.setActive(false);
	}
	else
	{
		MouseZUpActionMenu.setActive(true);
		MouseZDownActionMenu.setActive(true);
	}
}
function MouseZActionMenu::onSelect( %this, %id, %text )
{
	if(%id != 4)
	{
		MouseZUpActionMenu.setActive(false);
		MouseZDownActionMenu.setActive(false);
	}
	else
	{
		MouseZUpActionMenu.setActive(true);
		MouseZDownActionMenu.setActive(true);
	}
}
function MouseConfigDlg::onOK( %this )
{
	%xSens = MouseXSlider.getValue() * 2;
	%ySens = MouseYSlider.getValue() * 2;
	moveMap.bind( mouse, xaxis, "S", %xSens, "yaw" );
	%yFlags = InvertMouseTgl.getValue() ? "SI" : "S";
	moveMap.bind( mouse, yaxis, %yFlags, %ySens, "pitch" );
	switch ( MouseZActionMenu.getSelected() )
	{
		case 2: moveMap.bind( mouse, zaxis, cycleWeaponAxis );
		case 3: moveMap.bind( mouse, zaxis, cycleNextWeaponOnly );
		case 4: moveMap.bind( mouse, zaxis, MineNade );
		default: moveMap.unbind( mouse, zaxis );
	}
	$pref::MouseZUpAction = MouseZUpActionMenu.getSelected();
	$pref::MouseZDownAction = MouseZDownActionMenu.getSelected();
	Canvas.popDialog( MouseConfigDlg );
}
function MineNade( %val )
{
	if ( %val < 0 )
	{
		switch($pref::MouseZUpAction)
		{
			case 1: FFMine();
			case 2: FFGren();
			case 3: FFGrenMine();
		}
	}
	else
	{
		switch($pref::MouseZDownAction)
		{
			case 1: FFMine();
			case 2: FFGren();
			case 3: FFGrenMine();
		}
	}
}
function FFMine()
{
	throwMineMax(1);
	throwMineMax(0);
}
function FFGren()
{
	throwGrenadeMax(1);
	throwGrenadeMax(0);
}
function FFGrenMine() 
{
	if(loadout.getgrenadetype() $= "Grenade") FFGren();
	schedule(100, 0, FFMine);
}
};
activatepackage(WheelMineNade);

new GuiTextCtrl(MouseZUpActionText) {
	profile = "ShellTextCenterProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "50 215";
	extent = "130 22";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";
	text = "Wheel Up:";
};
new ShellPopupMenu(MouseZUpActionMenu) {
	profile = "ShellPopupProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "210 230";
	extent = "130 36";
	minExtent = "49 36";
	visible = "1";
	helpTag = "0";
	maxPopupHeight = "200";
	buttonBitmap = "gui/shll_pulldown";
	rolloverBarBitmap = "gui/shll_pulldownbar_rol";
	selectedBarBitmap = "gui/shll_pulldownbar_act";
	noButtonStyle = "0";
};
new GuiTextCtrl(MouseZDownActionText) {
	profile = "ShellTextCenterProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "210 215";
	extent = "130 22";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";
	text = "Wheel Down:";
};
new ShellPopupMenu(MouseZDownActionMenu) {
	profile = "ShellPopupProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "50 230";
	extent = "130 36";
	minExtent = "49 36";
	visible = "1";
	helpTag = "0";
	maxPopupHeight = "200";
	buttonBitmap = "gui/shll_pulldown";
	rolloverBarBitmap = "gui/shll_pulldownbar_rol";
	selectedBarBitmap = "gui/shll_pulldownbar_act";
	noButtonStyle = "0";
};
MouseZActionMenu.getGroup().Resize(125,104,390,320);
MouseZActionMenu.getGroup().add(MouseZUpActionText);
MouseZActionMenu.getGroup().add(MouseZUpActionMenu);
MouseZActionMenu.getGroup().add(MouseZDownActionText);
MouseZActionMenu.getGroup().add(MouseZDownActionMenu);
MouseZUpActionMenu.clear();
MouseZUpActionMenu.add( "FF Mine", 1 );
MouseZUpActionMenu.add( "FF Nade", 2 );
MouseZUpActionMenu.add( "FF Mine/Nade", 3 );
MouseZDownActionMenu.clear();
MouseZDownActionMenu.add( "FF Mine", 1 );
MouseZDownActionMenu.add( "FF Nade", 2 );
MouseZDownActionMenu.add( "FF Mine/Nade", 3 );
